
#import <appkit/appkit.h>

// The three state button...

// the values of these are arbitrary and chosen to avoid conflict
// with the NeXT #defines in ButtonCell.h...  use them with -setType:
#define MISC_CYCLIC_THREE_STATE	100	// cycles through three states
#define MISC_PLAIN_THREE_STATE	101	// alt click for third state

@interface ThreeStateButtonCell:ButtonCell
{
	char *thirdTitle;	// title for the third state
	id _thirdImage;		// image for the third state
	BOOL isCyclic;		// if not, ALT click gives third state.
	BOOL thirdState;	// if we're in the third state.
}

// the basics
- init;
- copyFromZone:(NXZone *)zone;
- free;

// setting and getting the third image/title
- (const char *)thirdTitle;
- setThirdTitle:(const char *)aString;
- setThirdIcon:(const char *)iconName;
- thirdImage;
- setThirdImage:image;
- setType:(int)aType;

// Need to override these to provide for the third state
- (const char *)stringValue;
- setStringValue:(const char *)aString;
- setStringValueNoCopy:(const char *)aString;
- (int)intValue;
- setIntValue:(int)anInt;
- (float)floatValue;
- setFloatValue:(float)aFloat;
- (double)doubleValue;
- setDoubleValue:(double)aDouble;

// these override the drawing to deal with the extra
// image/icon and title
- getDrawRect:(NXRect *)theRect;
- getTitleRect:(NXRect *)theRect;
- getIconRect:(NXRect *)theRect;
- calcCellSize:(NXSize *)theSize inRect:(const NXRect *)aRect;
- drawInside:(const NXRect *)aRect inView:controlView;
- highlight:(const NXRect *)cellFrame inView:controlView lit:(BOOL)flag;
- (BOOL)trackMouse:(NXEvent *)theEvent inRect:(const NXRect *)cellFrame
		ofView:controlView;
- performClick:sender;
- performAltClick:sender;
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

@end
