
#import "ThreeStateButtonCell.h"

// This would be a hell of a lot easier with NeXT's source code.  Since
// I don't have it, but I want to make sure that the same drawing mechanisms
// are used to render the third state of the button, I do a nasty hack.
// Whenever I want to go to the third state, I fake it and make the button
// think it's in the alternate state (of a normal button) but whenever it
// attempts to get the title or image, I swap in the third state button/image
// before the render and then switch back the true alt image/title upon
// finishing the render.  I use the same trick when the button is being queried
// about it's sizes for drawing areas, etc.  I swap icons and titles in and get
// the size they'd use, then I get the size of the correct icons, and then
// return the MAX of the two.  Without knowing exactly how NeXT does the
// calculations, I have to do a hack like this.  Since I'm essentially re-using
// their code when I take my measurements and do my rendering, that means that
// if it changes in the future, this class will follow the changes and keep
// doing the right thing, whatever that is.  I still think it's ugly, but it is
// a cute trick.

// As usual, ***** denotes an unfinished method.  This class is not at all
// done.  It won't do what it is supposed to do yet, at all!

@implementation ThreeStateButtonCell

- init
{
	id ret = [super init];
	thirdTitle = NULL;
	_thirdImage = nil;
	isCyclic = YES;
	thirdState = NO;
	return ret;
}

- copyFromZone:(NXZone *)zone
{ // ***** we may need something here...
	return [super copyFromZone:zone];
}

- free
{
	if (thirdTitle) free(thirdTitle);
	[_thirdImage free];  // should I do this?
	return [super free];
}

- (const char *)thirdTitle { return thirdTitle; }

- setThirdTitle:(const char *)aString
{
	if (thirdTitle) free(thirdTitle);
	thirdTitle = NXCopyStringBufferFromZone(aString, [self zone]);
	return self;
}

- setThirdIcon:(const char *)iconName
{
	[_thirdImage free];  // should I do this?
	_thirdImage = [NXImage findImageNamed:iconName];
	return self;
}

- thirdImage { return _thirdImage; }

- setThirdImage:image
{
	[_thirdImage free];  // should I do this?
	_thirdImage = image;
	return self;
}

- setType:(int)aType
{
	switch (aType) {
		case MISC_CYCLIC_THREE_STATE: isCyclic = YES; break;
		case MISC_PLAIN_THREE_STATE:  isCyclic = NO;  break;
		default: return [super setType:aType];
	}
	return self;
}

- (const char *)stringValue
{
	if (thirdState) return "alt";
	return [super stringValue];
}

- setStringValue:(const char *)aString
{
	thirdState = NO;
	if (aString) if (strlen(aString)) thirdState = YES;
	return [super setStringValue:aString];
}

- setStringValueNoCopy:(const char *)aString
{
	thirdState = NO;
	if (aString) if (strlen(aString)) thirdState = YES;
	return [super setStringValueNoCopy:aString];
}

- (int)intValue
{
	if (thirdState) return 2;
	return [super intValue];
}

- setIntValue:(int)anInt
{
	if (anInt == 2) thirdState = YES;
	else thirdState = NO;
	return [super setIntValue:anInt];
}

- (float)floatValue
{
	if (thirdState) return 2.0;
	return [super floatValue];
}

- setFloatValue:(float)aFloat
{
	if ((aFloat > 1.0) && (aFloat <= 2.0)) thirdState = YES;
	else thirdState = NO;
	return [super setFloatValue:aFloat];
}

- (double)doubleValue
{
	if (thirdState) return 2.0;
	return [super doubleValue];
}

- setDoubleValue:(double)aDouble
{
	if ((aDouble > 1.0) && (aDouble <= 2.0)) thirdState = YES;
	else thirdState = NO;
	return [super setDoubleValue:aDouble];
}

// Here's where the fun begins with us intercepting and fooling the button.
- getDrawRect:(NXRect *)theRect
{ // *****
	return [super getDrawRect:theRect];
}

- getTitleRect:(NXRect *)theRect
{ // *****
	return [super getTitleRect:theRect];
}

- getIconRect:(NXRect *)theRect
{ // *****
	return [super getIconRect:theRect];
}

- calcCellSize:(NXSize *)theSize inRect:(const NXRect *)aRect
{ // *****
	return [super calcCellSize:theSize inRect:aRect];
}

- drawInside:(const NXRect *)aRect inView:controlView
{ // *****
	return [super drawInside:aRect inView:controlView];
}

- highlight:(const NXRect *)cellFrame inView:controlView lit:(BOOL)flag
{ // *****
	return [super highlight:cellFrame inView:controlView lit:flag];
}

- (BOOL)trackMouse:(NXEvent *)theEvent inRect:(const NXRect *)cellFrame
		ofView:controlView
{ // *****
	return [super trackMouse:theEvent inRect:cellFrame ofView:controlView];
}

- performClick:sender
{ // *****
	return [super performClick:sender];
}

- performAltClick:sender
{ // *****
	if (thirdState) return self; // already to that state, so do nothing
	return [super performClick:sender];
}

- write:(NXTypedStream *)stream
{
	id ret = [super write:stream];
	// ***** write our stuff
	return ret;
}

- read:(NXTypedStream *)stream
{
	id ret = [super read:stream];
	// ***** write our stuff
	return ret;
}

@end
