#import "TriStateInspector.h"
#import <appkit/appkit.h>
#import "ThreeStateButtonCell.h"
#import "ThreeStateButton.h"

@implementation TriStateInspector

- init
{
    char buf[MAXPATHLEN + 1];
    id bundle;
    
    [super init];
    bundle = [NXBundle bundleForClass:[ThreeStateButton class]];
    [bundle getPath:buf forResource:"TriStateInspector" ofType:"nib"];
    [NXApp loadNibFile:buf owner:self withNames:NO fromZone:[self zone]];
    return self;
}

- (BOOL)wantsButtons { return YES; }

- buttonInspector:sender
{ // ***** bring up standard button inspector
	
	return self;
}

- revert:sender
{
	// Put string in text object
	[thirdTitle setStringValue:[object thirdTitle]];
	[thirdIcon setStringValue:[object thirdIcon]];
	[cyclic setIntValue:[[object cell] isCyclic]];
	return [super revert:sender];
}

- ok:sender
{
	[object setThirdTitle:[thirdTitle stringValue]];
	[object setThirdIcon:[thirdIcon stringValue]];
	[object setType:([cyclic intValue] ?
			MISC_CYCLIC_THREE_STATE : MISC_PLAIN_THREE_STATE)];
	return [super ok:sender];
}

@end
