
/* Generated by Interface Builder */
#import <objc/hashtable.h>
#include <stdlib.h>
#include <stdio.h>
#import <strings.h>
#import <objc/zone.h>
#import "String.h"

#define VERSION 2
@implementation String

 char *_strAllocCatFromZone(const char *str1, const char *str2, NXZone *aZone )
{
   unsigned size;
   char *tmpPtr;
   size = strlen( str1 ) + strlen( str2 ) + 1;
   if((tmpPtr = ( char * ) NXZoneMalloc(aZone, size )) == NULL )
    return NULL;
   strcpy( tmpPtr, str1 );
   strcat( tmpPtr, str2 );
   return tmpPtr; 
}


+ initialize
{
	[ String setVersion: VERSION ];
	return	self;
} 

- init
{
  [ super init ];
   string = NULL;
   delimiters = " \t\n\0";
   return self;
}

- free
{

   if( string != NULL )
     NXZoneFree( [ self zone ], string );
    return   [ super free ];
}

- clear
{
	if( string != NULL )
	free( string );
	string = NULL;
	return self;
}


- copyFromZone: ( NXZone * ) zone
{
	String *theCopy = [[ String allocFromZone: zone ] init ];
	if( string != NULL )
		theCopy->string = NXCopyStringBufferFromZone( string, zone );
	else string = NULL;
	if( subString != NULL )
		theCopy->subString = NXCopyStringBufferFromZone( subString, zone );
	else subString = NULL;
	if(string &&  startPtr >= string && startPtr<= (string + strlen( string )))
		theCopy->startPtr = string + (startPtr - string);
	else startPtr = NULL;
	if(string &&  endPtr >= string && endPtr <= ( string + strlen( string )))
		theCopy->endPtr = string + (endPtr - string);
	else endPtr = NULL;
	if(string &&  curPtr >= string && curPtr <= ( string + strlen( string )))
		theCopy->curPtr = string + (curPtr - string);
	else curPtr = NULL;
	return theCopy;
}

- ( const char* ) string
{
   return string;
}

- ( int ) length	// DIL 7/20/93
{
	return strlen( [self string] );
}

- setString: ( const char *) aString
{
   if( string != NULL )
     free( string );
   string = NXCopyStringBufferFromZone( aString, [ self zone ] );
   return self;
}

- replaceChar: ( char ) aChar withChar: ( char ) replaceChar
{
	char *ptr;
	
	if( string != NULL ){
		ptr = index( string, aChar );
		if( ptr )
			*ptr = replaceChar;
	}
	return self;
}

- setDelimiters: ( char * ) delList
{
	delimiters = NXZoneMalloc( [self zone], strlen(delList)+1 );
	strcpy(delimiters,delList);
	return self;
}

- ( const char * ) nthField: ( int ) fieldNumber
{
	char  *tmpPtr = string, *tmpBufPtr, *fieldPtr;
	int count = 0, index;
	
	if( string != NULL  ){
		// skip lead spaces and tabs to first field
		while( *tmpPtr != '\0' && ( *tmpPtr == delimiters  || *tmpPtr == '\t' ))
			 tmpPtr++;
		for( index = 0; index < fieldNumber; index++ ){
		 	// skip field
		 	while( *tmpPtr != '\0' && ( *tmpPtr != delimiter  && *tmpPtr != '\t' ))
				tmpPtr++;
		 	if( !tmpPtr ) return NULL;
		 	// skip spaces and tabs to next field
		 	while( *tmpPtr != '\0' && ( *tmpPtr == delimiter  || *tmpPtr == '\t' ))
				tmpPtr++;
		 	if( !tmpPtr ) return NULL;
		}
		// extract field
		fieldPtr = tmpPtr;
		while(*tmpPtr != '\0' && *tmpPtr != delimiter && *tmpPtr !='\t' ){
		 count++; tmpPtr++ ;
		}
		if( bufPtr != NULL )
			NXZoneFree([ self zone ], bufPtr );
		bufPtr = NXZoneMalloc( [ self zone ], count + 1 );
		tmpBufPtr = bufPtr;
		// copy the field
		while( fieldPtr != tmpPtr )
			*tmpBufPtr++ = *fieldPtr++;
		*tmpBufPtr = '\0';
		return bufPtr;
	}
	return NULL;
}


- ( const char * ) nthQuotedField: ( int ) fieldNumber
{
	int skip = fieldNumber * 2 + 1, count, index;  // number of qoutes to skip
	char *tmpPtr = string, *srcPtr, qouteChar = '\0';
	
	if( string == NULL ) return NULL;
	
	// set qoute char 
	while( *tmpPtr != '\0' && *tmpPtr != '\'' && *tmpPtr != '"' ) tmpPtr++;
	if( *tmpPtr == '\0' ) return NULL;
	qouteChar = *tmpPtr; 
	tmpPtr = string;	
	while( *tmpPtr != '\0' && skip ){
		if( *tmpPtr == qouteChar )
			skip--;
		tmpPtr++;
	}
	if( *tmpPtr == '\0' ) return NULL;
	
	srcPtr = tmpPtr;
	// size the string
	count = 0;
	while( *tmpPtr != '\0' && *tmpPtr != qouteChar ){
		count++;
		tmpPtr++;
	}
	if( *tmpPtr == '\0' ) return NULL;
		
	if( bufPtr != NULL )
			NXZoneFree([self zone ], bufPtr );
	bufPtr = NXZoneMalloc( [ self zone ], count + 1 );
	
	// copy the string
	tmpPtr = bufPtr;
	for( index = 0; index < count; index++ )
		*tmpPtr++ = *srcPtr++;
	*tmpPtr = '\0';
	return bufPtr;
}


- ( const char * ) lastField
{
	char *tmpPtr1, *tmpPtr2;
	
	if( string == NULL ) return NULL;
	
	tmpPtr1 = rindex( string, '\t' );
	tmpPtr2 = rindex( string, ' ' );
	if(( tmpPtr1 == NULL ) || ( tmpPtr1 < tmpPtr2 ))
		if( tmpPtr2 != NULL )
			tmpPtr1 = tmpPtr2;
		else return NULL;
		
	return ++tmpPtr1;
}

- ( const char * ) firstField
{
	return [ self nthField: 0 ];
}

- ( int ) numberFields
{
	char *tmpPtr = string;
	int count = 0;
	
	if( string != NULL  ){
		// skip lead spaces and tabs to first field
		while( *tmpPtr != '\0' && ( *tmpPtr == ' '  || *tmpPtr == '\t' ))
			 tmpPtr++;
		while(*tmpPtr != '\0'){
			count++;
			// skip field
			while( *tmpPtr != '\0' && ( *tmpPtr != ' '  && *tmpPtr != '\t' ))
				tmpPtr++;
			// skip spaces
			while( *tmpPtr != '\0' && ( *tmpPtr == ' '  || *tmpPtr == '\t' ))
			 tmpPtr++;

		}
	}
	return count;
}

- addStrings: (const char *) fields,  ...
{
  const char *aField;
  char *tmpPtr;
  va_list ptr;
   
  va_start( ptr, fields );
  if(( string == ( char * )NULL) && ( fields != NULL ))
   {
     string = NXCopyStringBufferFromZone( fields, [ self zone ] );
     aField = va_arg( ptr, char * );
   }
   else
      aField = fields;
   while ( aField != NULL ){
     tmpPtr = string;
     string = _strAllocCatFromZone( string, aField, [ self zone ] );
     if( tmpPtr != NULL ) free( tmpPtr );
     aField = va_arg( ptr, char * ); 
   }
  va_end( ptr ); 
          
    return self;
}

- addToEndOfString: ( const char *) aString
{
   char * tmpStr;
   if(( string != NULL ) && ( aString != NULL ))
    {
       tmpStr = string;
       string = _strAllocCatFromZone( string, aString, [ self zone ] );
	   free( tmpStr );
    }
   else 
     if( string == NULL )  string = 
	 			NXCopyStringBufferFromZone( aString, [self zone ] );    
   return self;
}

- addToFrontOfString: ( const char *) aString
{
   char * tmpStr;
   if(( string != NULL ) && ( aString != NULL ))
    {
       tmpStr = string;
       string = _strAllocCatFromZone( aString , string, [ self zone ]);
    }
   else 
     if( string == NULL )  
	 		string = NXCopyStringBufferFromZone( aString, [ self zone ] );    
   return self;
}

- addCharToEndOfString: ( char ) aChar
{
	char buf[ 2 ];
	buf[ 1 ] = '\0';
	buf[ 0 ] = aChar;
	[ self addToEndOfString: buf ];
	return self;
}

- addCharToFrontOfString: ( char ) aChar
{
	char buf[ 2 ];
	buf[ 1 ] = '\0';
	buf[ 0 ] = aChar;
	[ self addToFrontOfString: buf ];
	return self;
}

- read:(NXTypedStream *) s
{
    int thisVersion;
    [super read:s];
    thisVersion = NXTypedStreamClassVersion ( s, "String" );
    if(  thisVersion == 1 ){
       NXReadTypes(s, "*",  &string );
       delimiter =  ' ';
    }
    if(  thisVersion == [ String version ] )
       NXReadTypes(s, "*c",  &string, &delimiter );
   
    return self;
}

- write:(NXTypedStream *) s
{
    [super write:s];
    NXWriteTypes(s, "*c",  &string, &delimiter );
    return self;
}

// substring operations
- ( const char * ) start
{
	curPtr = string;
	return curPtr;
}

- ( const char * ) end
{
	curPtr = string;
	return curPtr;
}

- ( const char * ) lindex: ( char ) aChar
{
	char *tmpPtr = curPtr;
	curPtr = index( tmpPtr, aChar ); 
	return curPtr;
}

- ( const char * ) rindex: ( char ) aChar
{
	char *tmpPtr = curPtr;
	curPtr = rindex( tmpPtr, aChar );
	return curPtr;
}

- setStartMark
{
	startPtr = curPtr;
	return self;
}

- setEndMark
{
	endPtr = curPtr;
	return self;
}

- ( const char * ) subStringInclusive
{

	if(	string && 
		(( startPtr >= string ) && startPtr <= ( string + strlen( string )))
			 &&
		(( endPtr >= string ) && endPtr <= ( string + strlen( string )))
		&& ( endPtr > startPtr )){
		char *tmpPtr = startPtr, *ssPtr;
		int count = 0;
		
		while( tmpPtr - 1 != endPtr ){
			 count++;
			 tmpPtr++;
		}
		if( subString != NULL ){
			NXZoneFree( [ self zone ], subString );
			subString = NULL;
		}
		
		subString = NXZoneMalloc( [ self zone ], count + 1 );
		tmpPtr = startPtr;
		ssPtr = subString;
		while( tmpPtr - 1 != endPtr ){
			*ssPtr++ = *tmpPtr++;
		}
		*ssPtr++ = '\0';
		return subString;
	}
	return NULL;
}

- ( const char * ) subStringExclusive
{

	if(	string && 
		(( startPtr >= string ) && startPtr <= ( string + strlen( string )))
			 &&
		(( endPtr >= string ) && endPtr <= ( string + strlen( string )))
		&& ( endPtr > startPtr + 1 )){
		char *tmpPtr = startPtr + 1, *ssPtr;
		int count = 0;
		
		while( tmpPtr != endPtr ){
			 count++;
			 tmpPtr++;
		}
		if( subString != NULL ){
			NXZoneFree( [ self zone ], subString );
			subString = NULL;
		}
		
		subString = NXZoneMalloc( [ self zone ], count + 1 );
		tmpPtr = startPtr + 1;
		ssPtr = subString;
		while( tmpPtr != endPtr ){
			*ssPtr++ = *tmpPtr++;
		}
		*ssPtr++ = '\0';
		return subString;
	}
	return NULL;
}

- ( int ) subStringInclusiveLength	// DIL 7/20/93
{
	return strlen( [self subStringInclusive] );
}

- ( int ) subStringInclusiveLength	// DIL 7/20/93
{
	return strlen( [self subStringExclusive] );
}

@end
