/*  Added two methoods -setTicsVisible: (BOOL) and -isTicsVisible:
	Allows the user to select whether ticmarks are Visible or not.
	James Heiser  Sat Sep 25 13:59:15 GMT-0800 1993
*/

#import "MKProgressBar.h"

@implementation MKProgressBar

- initFrame:(const NXRect *)frameRect
{
    [super initFrame:frameRect];
    total = MAXSIZE;
    stepSize = DEFAULTSTEPSIZE;
	isTicsVisible = YES;
    return self;
}

- drawSelf:(const NXRect *)rects :(int)rectCount
{
    int linecount = 0;
	PSsetgray(NX_LTGRAY);
    NXRectFill(&bounds); 
    if (ratio > 0) {
        NXRect r = bounds;  
        r.size.width = bounds.size.width * ratio; 
        PSsetgray(NX_DKGRAY);
        NXRectFill(&r); 
    }
    PSsetgray(NX_DKGRAY);
    NXFrameRect(&bounds);
	if (isTicsVisible == YES)  {
		for (linecount = 1; linecount <= 24; ++linecount)  {
			PSnewpath();
			PSmoveto((int)((bounds.size.width / 24) * linecount), 0);
			PSlineto((int)((bounds.size.width / 24) * linecount),
				(int)(bounds.size.height / 4));
			if (linecount == 3 || linecount == 6 || linecount == 9 ||
				linecount == 12 || linecount == 15 || linecount ==18 ||
				linecount == 21)  {
			PSlineto((int)((bounds.size.width / 24) * linecount),
			(int)(bounds.size.height / 2));
			}
		PSstroke();
		}
	}
    return self;
}

- setStepSize:(int)value
{
    stepSize = value;
    return self;
}

- (int)stepSize
{
    return stepSize;
}

- setTicsVisible:(BOOL)aBool
{
    isTicsVisible = aBool;
	[self display];
    return self;
}

- (BOOL)isTicsVisible
{
    return isTicsVisible;
}

- setRatio:(float)newRatio
{
    if (newRatio > 1.0) newRatio = 1.0;
    if (ratio != newRatio) {
        ratio = newRatio;
        [self display];
    }
    return self;
}

- increment:sender
{
    count += stepSize;
    [self setRatio:(float)count/(float)total];
    return self;
}

- clear:sender
{
	count = 0;
	[self setRatio: 0];
	return self;
}

- read:(NXTypedStream*)stream
{
    [super read:stream];
    NXReadTypes(stream, "iii", &total, &stepSize, &isTicsVisible);
    return self;
}

- write:(NXTypedStream*)stream
{
    [super write:stream];
    NXWriteTypes(stream, "iii", &total, &stepSize, &isTicsVisible);
    return self;
}

- (const char *)getInspectorClassName
{
     return "MKProgressBarInspector";
}


@end
