#import "MKProgressPie.h"

@implementation MKProgressPie

- initFrame:(const NXRect *)frameRect
{
    [super initFrame:frameRect];
    total = MAXSIZE;
    stepSize = DEFAULTSTEPSIZE;
	[self setHidden:NO];
    return self;
}

- drawSelf:(const NXRect *)rects :(int)rectCount
{
/******** Fill the empty View with NX_LTGRAY *******/
	PSsetgray(NX_LTGRAY);
    NXRectFill(&bounds);

/******** Draw the initial Black circle *******/
	PSarc ((float)(bounds.size.width / 2),
		(float)(bounds.size.height / 2),
		(float)(bounds.size.height / 2),
		0, 360);
	PSsetgray(NX_BLACK);
	PSstroke();
	
/******** Draw the Empty Pie when 0 *******/
    if (ratio == 0.0) {
	    PSmoveto ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2));
	    PSarcn ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2),
			(float)(bounds.size.height / 2),
			90,90);
	    PSclosepath();
        PSsetgray(NX_BLACK);
	    PSstroke();
    }

/******** Draw the Full Pie when 100 *******/
    if (ratio >= 1.0) {
	    PSmoveto ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2));
	    PSarcn ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2),
			(float)(bounds.size.height / 2),
			90, -270);
	    PSclosepath ();
        PSsetgray(NX_DKGRAY);
	    PSfill();
	    PSmoveto ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2));
	    PSarcn ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2),
			(float)(bounds.size.height / 2),
			90, -270);
	    PSclosepath ();
        PSsetgray(NX_BLACK);
	    PSstroke();
    }

/******** Draw the Pie when between 0.0 and 1.0 *******/
    if (ratio < 1.0 && ratio > 0) {
	    PSmoveto ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2));
	    PSarcn ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2),
			(float)(bounds.size.height / 2),
			90, (float)(90 - 360 * ratio));
	    PSclosepath ();
        PSsetgray(NX_DKGRAY);
	    PSfill();
	    PSmoveto ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2));
	    PSarcn ((float)(bounds.size.width / 2),
			(float)(bounds.size.height / 2),
			(float)(bounds.size.height / 2),
			90, (float)(90 - 360 * ratio));
	    PSclosepath ();
        PSsetgray(NX_BLACK);
	    PSstroke();
    }

/******** If isHidden:YES fill with with NX_LTGRAY *******/
	if ([self isHidden] == YES)  {
        PSsetgray(NX_LTGRAY);
        NXRectFill(&bounds); 
//		fprintf(stderr, "It says it is hidden...JH\n");
	}
	
    return self;
}

- setStepSize:(int)value
{
    stepSize = value;
    return self;
}

- (int)stepSize
{
    return stepSize;
}

- setHidden:(BOOL)aBool
{
    isHidden = aBool;
    return self;
}

- (BOOL)isHidden
{
    return isHidden;
}

- setRatio:(float)newRatio
{
    if (newRatio > 1.0) newRatio = 1.0;
    if (ratio != newRatio) {
        ratio = newRatio;
        [self display];
    }
    return self;
}

- increment:sender
{
    count += stepSize;
    [self setRatio:(float)count/(float)total];
    return self;
}

- clear:sender
{
	count = 0;
	[self setRatio: 0];
	return self;
}

- read:(NXTypedStream*)stream
{
    [super read:stream];
    NXReadTypes(stream, "iii", &total, &stepSize, &isHidden);
    return self;
}

- write:(NXTypedStream*)stream
{
    [super write:stream];
    NXWriteTypes(stream, "iii", &total, &stepSize, &isHidden);
    return self;
}

- (const char *)getInspectorClassName
{
     return "MKProgressPieInspector";
}


@end
