
/* Generated by Interface Builder */

#import "ProgressView.h"
#import <appkit/Control.h>
#import <dpsclient/psops.h>
#import <appkit/color.h>
#import <appkit/Window.h>

@implementation ProgressView

- initFrame:(const NXRect *)frameRect
{
	[super initFrame:frameRect];
	bg = NXConvertGrayToColor(NX_LTGRAY);
	fg = NXConvertGrayToColor(NX_DKGRAY);
	bd = NXConvertGrayToColor(NX_BLACK);
	total = MAXSIZE;
	stepSize = DEFAULTSTEPSIZE;
	count = 0;
	ratio = 0.0;
	return self;
}

- drawSelf:(const NXRect *)rects :(int)rectCount
{
	NXSetColor(bg);
	NXRectFill(&bounds);
	if ((ratio > 0) && (ratio <= 1.0)) {
		NXRect r = bounds;
		r.size.width = bounds.size.width * ratio;
		NXSetColor(fg);
		NXRectFill(&r);
	}
	NXSetColor(bd);
	NXFrameRect(&bounds);
	return self;
}

- setStepSize:(int)value
{
	stepSize = value;
	return self;
}

- (int)stepSize { return stepSize; }
- (NXColor)bgColor { return bg; }
- (NXColor)fgColor { return fg; }
- (NXColor)bdColor { return bd; }

- setbgColor:(NXColor)color
{
	bg = color;
	return self;
}

- setfgColor:(NXColor)color
{
	fg = color;
	return self;
}

- setbdColor:(NXColor)color
{
	bd = color;
	return self;
}

- setRatio:(float)newRatio
{
	if (newRatio > 1.0) newRatio = 1.0;
	if (ratio != newRatio) {
		ratio = newRatio;
		[self display];
	}
	return self;
}


- takeIntValueFrom:sender
{
	int temp = [sender intValue];
	if ((temp < 0) || (temp > total)) return nil;
	count = temp;
	[self setRatio:(float)count/(float)total];
	return self;
}

- increment:sender
{
	count += stepSize;
	[self setRatio:(float)count/(float)total];
	return self;
}

- takeFloatValueFrom:sender
{
	[self setRatio:[sender floatValue]];
	return self;
}

- (const char *)inspectorName
{
	return "ProgressViewInspector";
}

- read:(NXTypedStream *)stream
{
	[super read:stream];
	NXReadTypes(stream, "ii", &total, &stepSize);
	bg = NXReadColor(stream);
	fg = NXReadColor(stream);
	bd = NXReadColor(stream);
	return self;
}

- write:(NXTypedStream *)stream
{
	[super write:stream];
	NXWriteTypes(stream, "ii", &total, &stepSize);
	NXWriteColor(stream, bg);
	NXWriteColor(stream, fg);
	NXWriteColor(stream, bd);
	return self;
}


@end
